﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace test
{
    public class date
    {
        public int id { set; get; }
        public string color { set; get; }
        public string name { set; get; }
        public decimal price { set; get; }

        public string time { get; set; }
    }

    class MyComparer : IEqualityComparer<date>
    {
        public bool Equals(date x, date y)
        {
            return x.id == y.id;
        }

        public int GetHashCode(date obj)
        {
            return obj.id.GetHashCode();
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            List<date> list1 = new List<date>() 
            {
                new date() { id = 1, color = "1", name = "name1", price = 1,time="时间" },
                new date() { id = 2, color = "2", name = "name2", price = 2,time="时间" },
                new date() { id = 3, color = "3", name = "name3", price = 3,time="时间" },
                new date() { id = 5, color = "5", name = "name5", price = 5,time="时间" },
                new date() { id = 6, color = "6", name = "name8", price = 8,time="时间" }
            };
            List<date> list2 = new List<date>() 
            {
                new date() { id = 1, color = "修改", name = "修改", price = 2,time="时间" },
                new date() { id = 8, color = "增加", name = "增加", price = 2,time="时间" }
            };
            //var result = list1.Union(list2, new MyComparer());//.Except(list1.Intersect(list2, new MyComparer()), new MyComparer());
            var result = list2.Union(list1, new MyComparer());
            foreach (var item in result)
            {
                Console.WriteLine("id = {0}, card = {1}, name = {2}, price = {3}", item.id, item.color, item.name, item.price,item.time);
            }
        }
    }
}
